<script setup lang="ts">
import { computed, onMounted, reactive } from "vue";
import { useS3ObjectStore } from "@/stores/s3objects";
import { useBucketStore } from "@/stores/buckets";
import { useNameStore } from "@/stores/names";
import dayjs from "dayjs";
import { useAuthStore } from "@/stores/users";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { Tooltip } from "bootstrap";
import { useS3KeyStore } from "@/stores/s3keys";

const objectRepository = useS3ObjectStore();
const bucketRepository = useBucketStore();
const nameRepository = useNameStore();
const userRepository = useAuthStore();
const s3keyRepository = useS3KeyStore();

let refreshTimeout: NodeJS.Timeout | undefined = undefined;

const uploadState = reactive<{
  loading: boolean;
  initialFetched: boolean;
}>({
  loading: true,
  initialFetched: false,
});

function abortMultipartUpload(
  bucketName: string,
  key?: string,
  uploadId?: string,
) {
  if (uploadId && key) {
    objectRepository.abortMultipartUpload(bucketName, key, uploadId).then();
  }
}

const uploadsInOwnBucketsPresent = computed<boolean>(() => {
  for (const entries of Object.entries(
    objectRepository.multiPartUploadsMapping,
  )) {
    const bucketName = entries[0];
    const uploads = entries[1];
    if (
      uploads.length > 0 &&
      bucketRepository.bucketMapping[bucketName]?.owner_id ==
        userRepository.currentUID
    ) {
      return true;
    }
  }
  return false;
});

function refreshMultipartUploads() {
  clearTimeout(refreshTimeout);
  refreshTimeout = setTimeout(() => {
    fetchMultipartUploads();
  }, 500);
}

function fetchMultipartUploads() {
  Promise.all(
    bucketRepository.ownBuckets.map((bucket) =>
      objectRepository.fetchMultipartUploads(bucket.name),
    ),
  ).finally(() => {
    uploadState.loading = false;
  });
}

onMounted(() => {
  // if uploads where already fetched, then don't show a loading screen
  if (Object.keys(objectRepository.multiPartUploadsMapping).length > 0) {
    uploadState.loading = false;
  }
  // First fetch s3 keys and then fetch uploads
  s3keyRepository.fetchS3Keys(() => {
    if (!uploadState.initialFetched) {
      uploadState.initialFetched = true;
      if (bucketRepository.ownBuckets.length > 0) {
        fetchMultipartUploads();
      } else {
        bucketRepository.fetchOwnBuckets().finally(fetchMultipartUploads);
      }
    }
  });
  Tooltip.getOrCreateInstance("#refreshUploadsButton");
});
</script>

<template>
  <div
    class="row border-bottom mb-4 pb-2 justify-content-between align-items-center"
  >
    <h2 class="w-fit mb-0">Multipart Uploads</h2>
    <div class="w-fit">
      <button
        class="btn btn-light me-2 shadow-sm border"
        @click="refreshMultipartUploads"
        id="refreshUploadsButton"
        data-bs-title="Refresh Multipart Uploads"
        data-bs-toggle="tooltip"
      >
        <font-awesome-icon icon="fa-solid fa-arrow-rotate-right" />
        <span class="visually-hidden">Refresh Data Buckets</span>
      </button>
    </div>
  </div>
  <p>
    When uploading large files to S3, a multipart upload process is utilized.
    This involves breaking the file into smaller chunks, which are then uploaded
    asynchronously. While these uploaded parts contribute to the bucket quotas,
    they are not displayed when listing all objects in a bucket. If a multipart
    upload is left incomplete or not properly aborted, these chunks can
    accumulate in your bucket without your awareness. However, aborting the
    erroneous multipart upload will release the occupied space.
  </p>
  <div v-if="uploadState.loading" class="text-center mt-5">
    <div class="spinner-border" role="status" style="width: 3rem; height: 3rem">
      <span class="visually-hidden">Loading...</span>
    </div>
  </div>
  <div class="accordion mt-2" v-else-if="uploadsInOwnBucketsPresent">
    <template v-for="bucket in bucketRepository.ownBuckets" :key="bucket">
      <div
        class="accordion-item"
        v-if="
          objectRepository.multiPartUploadsMapping[bucket.name] &&
          objectRepository.multiPartUploadsMapping[bucket.name].length > 0
        "
      >
        <h2 class="accordion-header">
          <button
            class="accordion-button"
            type="button"
            data-bs-toggle="collapse"
            :data-bs-target="`#collapse-${bucket.name}`"
            aria-expanded="true"
            :aria-controls="`#collapse-${bucket.name}`"
          >
            Bucket: {{ bucket.name }}
          </button>
        </h2>
        <div
          :id="`collapse-${bucket.name}`"
          class="accordion-collapse collapse show"
        >
          <div class="accordion-body">
            <table class="table table-striped align-middle">
              <thead>
                <tr>
                  <th scope="col">Key</th>
                  <th scope="col">Initiator</th>
                  <th scope="col">Initiated</th>
                  <th></th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="upload in objectRepository.multiPartUploadsMapping[
                    bucket.name
                  ]"
                  :key="upload.UploadId"
                >
                  <th scope="row">{{ upload.Key }}</th>
                  <td>{{ nameRepository.getName(upload.Initiator?.ID) }}</td>
                  <td>
                    {{ dayjs(upload.Initiated).format("YYYY-MM-DD HH:mm:ss") }}
                  </td>
                  <th class="text-end">
                    <button
                      type="button"
                      class="btn btn-danger btn-sm"
                      @click="
                        abortMultipartUpload(
                          bucket.name,
                          upload.Key,
                          upload.UploadId,
                        )
                      "
                    >
                      Abort
                    </button>
                  </th>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </template>
  </div>
  <div v-else class="text-center fst-italic fs-5 mt-5">
    No active multipart uploads
  </div>
</template>

<style scoped></style>
